diff --git a/sysdeps/generic/not-cancel.h b/sysdeps/generic/not-cancel.h
index 5df48f3da7..d3b53e48cf 100644
--- a/sysdeps/generic/not-cancel.h
+++ b/sysdeps/generic/not-cancel.h
@@ -49,10 +49,6 @@
   (void) __writev (fd, iov, n)
 # define __waitpid_nocancel(pid, stat_loc, options) \
   __waitpid (pid, stat_loc, options)
-#define __pause_nocancel() \
-  __pause ()
-#define __nanosleep_nocancel(requested_time, remaining) \
-  __nanosleep (requested_time, remaining)
 #define __fcntl64_nocancel(fd, cmd, ...) \
   __fcntl64 (fd, cmd, __VA_ARGS__)
 
diff --git a/sysdeps/unix/sysv/linux/Makefile b/sysdeps/unix/sysv/linux/Makefile
index bbab8f8cc3..ad6821ecf6 100644
--- a/sysdeps/unix/sysv/linux/Makefile
+++ b/sysdeps/unix/sysv/linux/Makefile
@@ -212,10 +212,10 @@ endif
 ifeq ($(subdir),io)
 sysdep_routines += xstatconv internal_statvfs internal_statvfs64 \
 		   sync_file_range fallocate fallocate64 \
-		   close_nocancel fcntl_nocancel nanosleep_nocancel \
+		   close_nocancel fcntl_nocancel \
 		   open_nocancel open64_nocancel \
 		   openat_nocancel openat64_nocancel \
-		   pause_nocancel read_nocancel pread64_nocancel \
+		   read_nocancel pread64_nocancel \
 		   waitpid_nocancel write_nocancel statx_cp
 
 sysdep_headers += bits/fcntl-linux.h
diff --git a/sysdeps/unix/sysv/linux/nanosleep_nocancel.c b/sysdeps/unix/sysv/linux/nanosleep_nocancel.c
deleted file mode 100644
index d6442bf4f7..0000000000
--- a/sysdeps/unix/sysv/linux/nanosleep_nocancel.c
+++ /dev/null
@@ -1,29 +0,0 @@
-/* Linux nanosleep syscall implementation -- non-cancellable.
-   Copyright (C) 2018-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <time.h>
-#include <sysdep-cancel.h>
-#include <not-cancel.h>
-
-int
-__nanosleep_nocancel (const struct timespec *requested_time,
-		      struct timespec *remaining)
-{
-  return INLINE_SYSCALL_CALL (nanosleep, requested_time, remaining);
-}
-hidden_def (__nanosleep_nocancel)
diff --git a/sysdeps/unix/sysv/linux/not-cancel.h b/sysdeps/unix/sysv/linux/not-cancel.h
index 041fd00111..192a0a5195 100644
--- a/sysdeps/unix/sysv/linux/not-cancel.h
+++ b/sysdeps/unix/sysv/linux/not-cancel.h
@@ -72,12 +72,6 @@ __writev_nocancel_nostatus (int fd, const struct iovec *iov, int iovcnt)
 /* Uncancelable waitpid.  */
 __typeof (waitpid) __waitpid_nocancel;
 
-/* Uncancelable pause.  */
-__typeof (pause) __pause_nocancel;
-
-/* Uncancelable nanosleep.  */
-__typeof (__nanosleep) __nanosleep_nocancel;
-
 /* Uncancelable fcntl.  */
 __typeof (__fcntl) __fcntl64_nocancel;
 
@@ -91,8 +85,6 @@ hidden_proto (__pread64_nocancel)
 hidden_proto (__write_nocancel)
 hidden_proto (__close_nocancel)
 hidden_proto (__waitpid_nocancel)
-hidden_proto (__pause_nocancel)
-hidden_proto (__nanosleep_nocancel)
 hidden_proto (__fcntl64_nocancel)
 #endif
 
diff --git a/sysdeps/unix/sysv/linux/pause_nocancel.c b/sysdeps/unix/sysv/linux/pause_nocancel.c
deleted file mode 100644
index 04f6fcf5e3..0000000000
--- a/sysdeps/unix/sysv/linux/pause_nocancel.c
+++ /dev/null
@@ -1,33 +0,0 @@
-/* Linux pause syscall implementation -- non-cancellable.
-   Copyright (C) 2018-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <signal.h>
-#include <unistd.h>
-#include <sysdep-cancel.h>
-#include <not-cancel.h>
-
-int
-__pause_nocancel (void)
-{
-#ifdef __NR_pause
-  return INLINE_SYSCALL_CALL (pause);
-#else
-  return INLINE_SYSCALL_CALL (ppoll, NULL, 0, NULL, NULL);
-#endif
-}
-hidden_def (__pause_nocancel)